{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  :: QuickReport 3.0 for Delphi 3.0/4.0/5.0                  ::
  ::                                                         ::
  :: Simple report with graphics                             ::
  ::                                                         ::
  :: Copyright (c) 1995-1999 QuSoft AS                       ::
  :: All Rights Reserved                                     ::
  ::                                                         ::
  :: web: http://www.qusoft.com  fax: +47 22 41 74 91        ::
  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }
unit BarcodeReport;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Qrctrls, QuickRpt, Db, DBTables, ExtCtrls, OleCtrls, DBOleCtl,
  BARCODELib_TLB;

type
  TForm2 = class(TForm)
    QuickRep1: TQuickRep;
    Table1: TTable;
    DetailBand1: TQRBand;
    Table1SpeciesNo: TFloatField;
    Table1Category: TStringField;
    Table1Common_Name: TStringField;
    Table1SpeciesName: TStringField;
    Table1Lengthcm: TFloatField;
    Table1Length_In: TFloatField;
    Table1Notes: TMemoField;
    Table1Graphic: TGraphicField;
    QRDBText1: TQRDBText;
    ColumnHeaderBand1: TQRBand;
    QRLabel1: TQRLabel;
    QRLabel2: TQRLabel;
    QRImage1: TQRImage;
    MW6Barcode1: TMW6Barcode;
    procedure DetailBand1BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

procedure TForm2.DetailBand1BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
var
        bwidth: Integer;
        bheight: Integer;
        borientation: SmallInt;
begin
        borientation := 0;

        MW6Barcode1.SymbologyType := 4;
        MW6Barcode1.NarrowBarWidth := 0.07;
        MW6Barcode1.BarHeight := 2.0;
        MW6Barcode1.ShowText := true;
        MW6Barcode1.Orientation := borientation;
        MW6Barcode1.Data := Table1.FieldByName(QRDBText1.Caption).AsString;

        // Lock the canvas
        QRImage1.Canvas.Lock();

        QRImage1.Canvas.FloodFill(0, 0, clWhite, fsBorder);

        bwidth := 0;
        bheight := 0;
        // Get the barcode width and height
        MW6Barcode1.GetActualSize(true, 0, bwidth, bheight);

        if (borientation = 0) Or (borientation = 2)
        then
        begin
                MW6Barcode1.SetSize(bwidth + 30, bheight + 40);
                QRImage1.Width := bwidth + 30;
                QRImage1.Height := bheight + 40;
        end
        else
        begin
                MW6Barcode1.SetSize(bheight + 30, bwidth + 40);
                QRImage1.Width := bheight + 30;
                QRImage1.Height := bwidth + 40;
        end;

        // Render the barcode onto the image control
        MW6Barcode1.Render(QRImage1.Canvas.Handle, 0, 0);

        // Unlock the canvas
        QRImage1.Canvas.Unlock();
end;

end.
